--
-- BaleCounter
-- Specialization for baler to display a bale counter.
--
-- @author  	Benjamin Biot (J&B Modding)
-- @version 	v1.0
-- @date  		30/11/10
-- 
-- @edit	[FSM]Chefkoch
-- Did not colidate with the same script now

MyBaleCounter = {};

function MyBaleCounter.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Baler, specializations);
end;

function MyBaleCounter:load(xmlFile)
	self.SetBaleCount= SpecializationUtil.callSpecializationsFunction("SetBaleCount");
	--  HUD --
	self.File = Utils.getFilename("Textures/baleHud.dds", self.baseDirectory);
	self.hudPoxX = 0.5;
    self.hudPoxY = 1-0.150; 
    self.hudWidth = 0.264;
    self.hudHeight = 0.156;
    self.HUDNHBB = Overlay:new("HUDNHBB", self.File, self.hudPoxX, self.hudPoxY, self.hudWidth, self.hudHeight);
    self.HUD = false;
	
	self.MyTotalBalesCount = 0;
	self.MyCurrentBalesCount = 0;
	self.MyNoRopesBalesCount = 0;
end;

function MyBaleCounter:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
   local MyTotalBalesCount =  Utils.getNoNil(getXMLInt(xmlFile, key.."#MyTotalBalesCount"),0);
   local MyNoRopesBalesCount =  Utils.getNoNil(getXMLInt(xmlFile, key.."#MyNoRopesBalesCount"),0);
   self.MyTotalBalesCount = MyTotalBalesCount;
   self.MyNoRopesBalesCount = MyNoRopesBalesCount;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function MyBaleCounter:getSaveAttributesAndNodes(nodeIdent)
   local MyTotalBalesCount= Utils.getNoNil(self.MyTotalBalesCount, 0);
   local MyNoRopesBalesCount= Utils.getNoNil(self.MyNoRopesBalesCount, 0);
    local attributes = 'MyTotalBalesCount="'..string.format("%.1f",MyTotalBalesCount)..'" MyNoRopesBalesCount="'..string.format("%.1f",MyNoRopesBalesCount)..'"';
   return attributes, nil;
end;

function MyBaleCounter:delete()
end;

function MyBaleCounter:readStream(streamId, connection)
    self.MyTotalBalesCount = streamReadInt32(streamId);
    self.MyNoRopesBalesCount = streamReadInt32(streamId);
    self.MyCurrentBalesCount = streamReadInt32(streamId);
end;

function MyBaleCounter:writeStream(streamId, connection)
    streamWriteInt32(streamId, self.MyTotalBalesCount);
    streamWriteInt32(streamId, self.MyNoRopesBalesCount);
    streamWriteInt32(streamId, self.MyCurrentBalesCount);
end;

function MyBaleCounter:readUpdateStream(streamId, timestamp, connection)
end;

function MyBaleCounter:writeUpdateStream(streamId, connection, dirtyMask)
end;

function MyBaleCounter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MyBaleCounter:keyEvent(unicode, sym, modifier, isDown)
end;

function MyBaleCounter:update(dt)		
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.ACTIVATE_OBJECT) then
			self.HUD = not self.HUD;
		end;
    end;
end;

function MyBaleCounter:updateTick(dt)	
end;

function MyBaleCounter:draw()
	setTextBold(true);
	setTextColor(0, 0, 0, 1.0);
	if self.HUD then
		self.HUDNHBB:render();
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("HUD_OFF"), self.typeDesc), InputBinding.ACTIVATE_OBJECT);
		if self.MyCurrentBalesCount~= nil then
			renderText(0.565, 0.945, 0.020, string.format(self.MyCurrentBalesCount)); -- 0.951 
		end;
		if self.MyTotalBalesCount~= nil then
			renderText(0.565, 0.89, 0.020, string.format(self.MyTotalBalesCount));
		end;
	else
        g_currentMission:addHelpButtonText(string.format(g_i18n:getText("HUD_ON"), self.typeDesc), InputBinding.ACTIVATE_OBJECT);	
	end;
end;

function MyBaleCounter.dropBale(self, baleIndex)
	if self.MyCurrentBalesCount ~= nil and self.MyTotalBalesCount ~= nil and self.MyNoRopesBalesCount ~= nil then
		self.MyCurrentBalesCount = self.MyCurrentBalesCount +1;
		self.MyTotalBalesCount = self.MyTotalBalesCount +1;
		self.MyNoRopesBalesCount = self.MyNoRopesBalesCount +1;
	end;
end;

Baler.dropBale = Utils.appendedFunction(Baler.dropBale, MyBaleCounter.dropBale);